/******************************************************************
 *  Character Device Driver: charDev1.c                            
 *  gcc -O2 -DMODULE -D__KERNEL__ -W -Wall -Wstrict-prototypes    
 *  -Wmissing-prototypes -isystem                                 
 *  /lib/modules/`uname -r`/build/include                         
 *  -c -o charDev1.o charDev1.c                                     
 *  ***************************************************************/

#include <linux/kernel.h>  /* Needed for KERN_ALERT */
#include <linux/module.h>  /* Needed by all modules */
#include <linux/fs.h>
#include <asm-i386/current.h>
#include <linux/sched.h>

/*******************************************/
#define CHAR_DEV_NAME "myCharDev"

/*******************************************/
 static int myOpen(struct inode *, struct file *) ;
 static int myRelease(struct inode *, struct file *) ;
 static int majorNo ;  // Major device number
 static struct file_operations fileOps = {  // linux/fs.h
          open:  myOpen,
          release: myRelease
 } ; // charDev operation names - pointer to functions

int init_module(void) {
    printk("Inside the init_module\n");
    majorNo = register_chrdev(0, CHAR_DEV_NAME, &fileOps) ;
                               // linux/fs.h
    if(majorNo < 0) {
        printk("Registration failed - majorNo: %d\n", majorNo) ;
        return majorNo ;
    }
    printk("Make a node: mknod /dev/myCharDev c %d 0\n", majorNo) ;
    return 0;
}
void cleanup_module(void) {
    unregister_chrdev(majorNo, CHAR_DEV_NAME) ;
     printk("Inside the cleanup_module\n");
}  

static int myOpen(struct inode *indP, struct file *fP) {
    printk("<1>Inside myOpen\n") ;
    printk("<1>Exec File: %s\n", current -> comm) ;
    printk("<1>State: %ld\n",    current -> state) ;
    printk("<1>Process ID: %d\n",current -> pid) ;
    return 0 ;
}

static int myRelease(struct inode *indP, struct file *fP) {
        printk("Inside myRelease\n") ;
    return 0 ;
}


