/******************************************************************
 *  Character Device Driver: charDev2.c                            
 *  gcc -O2 -DMODULE -D__KERNEL__ -W -Wall -Wstrict-prototypes    
 *  -Wmissing-prototypes -isystem                                 
 *  /lib/modules/`uname -r`/build/include                         
 *  -c -o charDev2.o charDev2.c                                   
 *  ***************************************************************/

#include <linux/kernel.h>  /* Needed for KERN_ALERT */
#include <linux/module.h>  /* Needed by all modules */
#include <linux/fs.h>
#include <asm-i386/current.h>
#include <linux/sched.h>

/*******************************************/
#define CHAR_DEV_NAME "myCharDev"

/*******************************************/
 static int myOpen(struct inode *, struct file *) ;
 static int myRelease(struct inode *, struct file *) ;
 static int majorNo ;  // Major device number
 static struct file_operations fileOps = {  // linux/fs.h
            open:  myOpen,
          // read: myRead, 
          // write: myWrite,
           release: myRelease
 } ; // charDev operation names - pointer to functions

int init_module(void) {
    printk("Inside the init_module\n");
    majorNo = register_chrdev(0, CHAR_DEV_NAME, &fileOps) ;
                                     // linux/fs.h
    if(majorNo < 0) {
       printk("Registration failed - majorNo: %d\n", majorNo) ;
       return majorNo ;
     }
     printk("Make a node: mknod /dev/myCharDev c %d 0\n", majorNo) ;
     return 0;
}
void cleanup_module(void) {
     unregister_chrdev(majorNo, CHAR_DEV_NAME) ;
     printk("Inside the cleanup_module\n");
     
}  

static int myOpen(struct inode *indP, struct file *fP) {
     struct task_struct *p ;
     pid_t pid ;
     int i ;

     p = current ;
     printk("<1>Inside myOpen\n") ;
     printk("<1>State: %ld\n", current -> state) ;
     pid = p -> pid ;
     printk("<1>Process ID: %d\n", pid) ;
     p = p -> prev_task ;
     for(i=1; p -> pid != pid; ++i) {
          printk("<1>--> Process ID: %d\nProcess State: %ld\n", 
                    p -> pid, p -> state) ;
          p = p -> prev_task ;
     }
     printk("<1>No. of Processes: %d\n", i-1) ;
     return 0 ;
}

static int myRelease(struct inode *indP, struct file *fP) {
       printk("Inside myRelease\n") ;
       return 0 ;
}


