/*  hello-2.c - Demonstrating the module_init() and module_exit() macros.  This     is the preferred over using init_module() and cleanup_module().
*/

#include <linux/module.h>   // Needed by all modules
#include <linux/kernel.h>   // Needed for KERN_ALERT
#include <linux/init.h>     // Needed for the macros


static int secondModule_init(void)
{
    printk(KERN_ALERT "Load the 2nd Module\n");
    return 0;
}


static void secondModule_exit(void)
{
    printk(KERN_ALERT "Remove the 2nd Module\n");
}


module_init(secondModule_init);
module_exit(secondModule_exit);
